/*-------------------------------------------------------------------
 *
 *  @file push.h
 *
 *  @author Collin R. Mulliner <collin@mulliner.org>
 *
 *  (c) Collin R. Mulliner
 *
 *  This is part of the Bluetooth Location Tracker (BLT) project.
 *
 *-------------------------------------------------------------------*/

/*
 * This file is part of blt_server
 *
 * blt_server is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * blt_server is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with blt_server; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
#ifndef __PUSH_H__
#define __PUSH_H__

struct blt_push_t {

	struct blt_tracker_client_session_t *tracker;
	
	struct blt_push_t *prev;
};

struct blt_pusher_t {

	struct blt_push_t *first;
	struct blt_push_t *last;
	
	pthread_mutex_t lock;
	pthread_cond_t sig;
	
	int status;
};
#endif

void blt_push_init(struct blt_pusher_t *p);
void blt_push_destroy(struct blt_pusher_t *p);
void blt_push_put(struct blt_pusher_t *p, struct blt_push_t *n);
int blt_push_get(struct blt_pusher_t *p, struct blt_push_t **n);
void *blt_pusher(void *args);
